﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using Com.Piwigo.Uploader.DTO;

namespace Com.Piwigo.Uploader.Helper
{
    internal static class MainAppHelper
    {
        internal static void showdErrorMessageBox(ApplicationException aEx)
        {
            System.Windows.Forms.MessageBox.Show(aEx.Message, "Error", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
        }

        internal static System.Windows.Forms.TreeNode buildAlbumToNode(LocalAlbum aAlbum)
        {
            System.Windows.Forms.TreeNode aNode = new System.Windows.Forms.TreeNode(aAlbum.Name,1,1);
            aNode.ToolTipText = aAlbum.LocalDir;
            aNode.Tag = aAlbum;

            foreach (LocalImage Img in aAlbum.LocalImages)
            {
                System.Windows.Forms.TreeNode imgNode = new System.Windows.Forms.TreeNode(Img.Name, 2, 2);
                imgNode.ToolTipText = Img.LocalFile;
                imgNode.Tag = Img;
                aNode.Nodes.Add(imgNode);
            }

            foreach (LocalAlbum Alb in aAlbum.SubAlbums)
            {
                aNode.Nodes.Add(buildAlbumToNode(Alb));
            }

            return aNode;
        }

        internal static void BuildAlbumTree(System.Windows.Forms.TreeView aTree, LocalAlbumList lstAlbum)
        {
            System.Windows.Forms.TreeNode root = aTree.Nodes[0];
            if (root.Nodes.Count > 0)
            {
                root.Nodes.Clear();
            }
            //System.Windows.Forms.TreeNode root = new System.Windows.Forms.TreeNode("Albums", 0, 0);
            //aTree.Nodes.Add(root);
            //ModelManager.Instance.SelectedNode = root;
            //aTree.SelectedNode = root;

            foreach (LocalAlbum Alb in lstAlbum)
	        {
                root.Nodes.Add(buildAlbumToNode(Alb));
	        }

            aTree.ExpandAll();
        }

        #region thumb
        internal static string MakeThumb(FileInfo fi, String ext, int size)
        {
            // create an image object, using the filename we just retrieved
            System.Drawing.Image image = System.Drawing.Image.FromFile(fi.FullName);

            // create the actual thumbnail image
            System.Drawing.Image thumbnailImage = image.GetThumbnailImage(size, size, new System.Drawing.Image.GetThumbnailImageAbort(ThumbnailCallback), IntPtr.Zero);

            // make a memory stream to work with the image bytes
            FileStream imageStream = new FileStream(ext, FileMode.OpenOrCreate);

            // put the image into the memory stream
            thumbnailImage.Save(imageStream, System.Drawing.Imaging.ImageFormat.Jpeg);

            imageStream.Close();
            return ext;
        }

        /// <summary>
        /// Required, but not used
        /// </summary>
        /// <returns>true</returns>
        internal static bool ThumbnailCallback()
        {
            return true;
        }

        #endregion thumb
    }
}
